<?php

namespace Wics\Model;


class Order{

	public $webshopName;
	public $orderReference;
	public $notes;
	public $deliveryDate;
	public $invoiceAddress  = array("company" => "", "name" => "",  "street" => "", "streetNumber" => "", "extension" => "", "zipcode" => "", "city" => "","state" => "", "email" => "",  "country" => array("iso" => "")  );
	public $deliveryAddress = array("company" => "", "name" => "",  "street" => "", "streetNumber" => "", "extension" => "", "zipcode" => "", "city" => "","state" => "", "email" => "", "country" => array("iso" => "")  );
	public $ownerId;
	public $lines ;

	public function __construct(\WC_Order $order){

		
	
		// on create date
		//$this->order_date = date('Y-m-d H:i:s');
		$this->deliveryDate = $date = date("Y-m-d", strtotime("+1 day"));
		
		//test
		$this->ownerId = \Wics\Settings::getSetting('customer_id');
		
		// check name
		$this->orderReference =  $order->get_order_number();
		$this->notes = [$order->customer_note];
		
		
		// delivery date check required
		// check postnl types
		//$this->delivery_mode = $order->get_shipping_method();
		
		// check if adress is not empty
		if($order->get_shipping_address_1())
		{
			$this->deliveryAddress["name"] = $order->get_shipping_first_name() . " " . $order->get_shipping_last_name();
			$this->deliveryAddress["company"] = $order->get_shipping_company();
			$splitDeliveryStreet = $this->split_street($order->get_shipping_address_1());
			$this->deliveryAddress["street"] =  $splitDeliveryStreet["street"];
			$this->deliveryAddress["streetNumber"] = $splitDeliveryStreet["number"];
			$this->deliveryAddress["extension"] = $order->get_shipping_address_2();
			$this->deliveryAddress["city"] = $order->get_shipping_city();
			$this->deliveryAddress["zipcode"] = $order->get_shipping_postcode();
			$this->deliveryAddress["country"]["iso"] = $order->get_shipping_country();
			$this->deliveryAddress["phone"] = $order->get_billing_phone();
			
		/**
		 * If Shipment address is the same, use email from shipment address.
		 */
		if($order->get_shipping_email){
			$this->deliveryAddress["email"] = $order->get_shipping_email;
		} else {
			$this->deliveryAddress["email"] = $order->get_billing_email();
		}
		
			
		
		
		} 
		
		
		
		if($order->shipping_address_1)
		{
		
		$this->invoiceAddress["name"] = $order->get_billing_first_name() . " " . $order->get_billing_last_name();
		$this->invoiceAddress["company"] = $order->get_billing_company();
		$splitInvoiceStreet = $this->split_street($order->get_billing_address_1());
		$this->invoiceAddress["street"] = $splitInvoiceStreet["street"];
		$this->invoiceAddress["streetNumber"] = $splitInvoiceStreet["number"];
		$this->invoiceAddress["extension"] = $order->get_billing_address_2();
		$this->invoiceAddress["city"] = $order->get_billing_city();
		$this->invoiceAddress["zipcode"] = $order->get_billing_postcode();
		$this->invoiceAddress["country"]["iso"] = $order->get_billing_country();
		$this->invoiceAddress["email"] = $order->get_billing_email();
		$this->invoiceAddress["phone"] = $order->get_billing_phone();
		}
		// check
		//$this->invoice_sub_country = $order->billing_state;
		
		
		
		static $productFactory;
		foreach($order->get_items() as $item){
			
			if(!isset($productFactory)){
				$productFactory = new \WC_Product_Factory;
			}
			
			$product_variation_id = $item['variation_id'];
			
			// 	Check if product have variation.
			if ($product_variation_id) {
				$product = $productFactory->get_product($item['variation_id']);
			} else {
				$product = $productFactory->get_product($item['product_id']);
			}
			
			$this->lines[] = new OrderLine($item, $product);
		}

		
	}
	
	function split_street($street)
	{
		$pattern = '/^(\d*[\wäöüß\d \'\-\.]+)[,\s]+(\d+)\s*([\wäöüß\d\-\/]*)$/i';
		$matchResult = preg_match($pattern, $street, $aMatch);
	
		$street = (isset($aMatch[1])) ? $aMatch[1] : '';
		$number = (isset($aMatch[2])) ? $aMatch[2] : '';
	
		return array('street' => $street, 'number' => $number);
	}
}

?>