<?php

namespace Wics;

class UpdateOrder{
	
	
	function update(){
		if (\Wics\Settings::getSetting ( 'sync-order-status' ) == true) {
			$woo_orders = $this->get_woo_orders ();
			
			WelppModule::getInstance()->log ( "Starting update order shipment details." );
			foreach ( $woo_orders as $woo_order ) {
				$trackAndTrace = get_post_meta ( $woo_order->id, '_order_track', true );
				
	
				if (empty ( $trackAndTrace )) {
					$result = $this->getShipmentForOrder ( $woo_order->id );
					
					if ($result->success == true) {
						$trackAndTraceUrl = $result->data->shippingDetails->trackAndTraceUrl;
						$trackAndTrace = $result->data->shippingDetails->trackAndTrace;
						$provider = $result->data->shippingOption->combined;
						
						$woo_order->update_status ( 'completed' );
						WelppModule::getInstance()->log ( sprintf ( "Status of order with id %d was set to completed", $woo_order->id ) );
						
						if (isset ( $trackAndTraceUrl ) && isset ( $trackAndTrace )) {
							// update fields
							update_post_meta ( $woo_order->id, '_order_track_url', $trackAndTraceUrl );
							update_post_meta ( $woo_order->id, '_order_track', $trackAndTrace );
							update_post_meta ( $woo_order->id, '_order_track_provider', $provider );
							WelppModule::getInstance()->log ( sprintf ( "Order with id %d has been updated with Shipment Details from Welpp.", $woo_order->id ) );
							
						}
					}
				}
			}
		}
	}
	
	private function getShipmentForOrder($order_id){
		$request = new CurlRequest("GET", "shipment/" . $order_id);
		$request->execute();
		return $request->getResult();
	}
	
	private function get_woo_orders()
	{
		
		$args = get_posts( array(
      		  'post_type'   => 'shop_order',
      		  'post_status' => array( 'wc-processing', 'wc-completed' )
		) );
	
		$orders = array();
		$loop = new \WP_Query($args);
		
		foreach ($loop->query as $order){
			$orders[$order->ID] = new \WC_Order($order->ID);
		}
		
		return $orders;
	}
}

?>