<?php
namespace Wics;


class UpdateStock{
	
	function update(){
		error_log("begin stock update.");
		if(\Wics\Settings::getSetting('sync-stock') == true){
			
		WelppModule::getInstance()->log("start stock update.");
		$welppStockItems = $this->getWelpStock();
		
		foreach ($welppStockItems as $welppStockItem){
			$product = $this->getProduct($welppStockItem->code);
			if($product){
				$stock_quantity = $product->get_stock_quantity();
		
				if(isset($stock_quantity) && $stock_quantity != $welppStockItem->freeStock){
		
					$newStock = $product->set_stock($welppStockItem->freeStock);
					if($newStock){
						WelppModule::getInstance()->log(sprintf("Setting stock level to %d for item %s . Previous stock level was: %d .", $newStock, $product->get_sku(), $stock_quantity));
					}
				}
			}
		}
	 }	
	}
	
	private function getWelpStock(){
	
		$pageCount = 1;
		$hasPages = true;
		$items = null;
	
		while ($hasPages){
			$request = new CurlRequest("GET", "stock/list?page=". $pageCount);
			$request->execute();
			$results = $request->getResult();
			
			if($results->data != null){
				foreach ($results->data as $result)
				{
					$items[] = $result;
				}
				$pageCount++;
			} else {
				$hasPages = false;
			}
		}
	
		return $items;
	}
	
	 function getProduct($sku){
		// 	specific item
		global $wpdb;
		$product = null;
		$product_id =
		$wpdb->get_var(
				$wpdb->prepare(
						"SELECT post_id FROM $wpdb->postmeta WHERE meta_key='_sku' AND meta_value='%s' LIMIT 1",
						$sku
				)
		);
	
		if ($product_id) {
			return new \WC_Product($product_id);
		}
		return false;
	}
	
	
	
	
	
}

?>