<?php

function wics_saveSettings()
{
    \Wics\Settings::putSetting('url', $_POST['wics-url']);
    \Wics\Settings::putSetting('username', $_POST['wics-username']);
    \Wics\Settings::putSetting('password', $_POST['wics-password']);
    \Wics\Settings::putSetting('customer_id', $_POST['wics-customer-id']);
    \Wics\Settings::putSetting('sync-order-status', $_POST['wics-sync-order-status']);
    \Wics\Settings::putSetting('sync-stock', $_POST['wics-sync-stock']);

    if (isset($shopSaveResponse['error'])) {
        \Wics\Settings::putSetting('url', '');
        \Wics\Settings::putSetting('username', '');
        \Wics\Settings::putSetting('password', '');
        \Wics\Settings::putSetting('customer_id', '');
        \Wics\Settings::putSetting('sync-order-status', '');
        \Wics\Settings::putSetting('sync-stock', '');
        return array(
            'color'=>'red',
            'message'=>'De gegevens zijn onjuist en de instellingen konden niet worden opgeslagen.'
        );
    }
    return array(
        'color'=>'green',
        'message'=>'De instellingen zijn successvol opgeslagen.'
    );
}

$message = false;
if (isset($_POST['wics-url'])) {
    $message = wics_saveSettings($_POST['wics-url']);
}
?>
<form method="post" action="">
    <table class="form-table">
        <tbody>
            <tr>
                <th colspan="2">
                    <div id="icon-options-general" class="icon32">
                        <br />
                    </div>
                    <h2>WELPP - INTEGRATION</h2>
                </th>
            </tr>
            <?php if ($message !== false): ?>
                <tr>
                    <td colspan="2">
                        <span style="color:<?php echo $message['color'] ?>"><?php echo $message['message'] ?></span>
                    </td>
                </tr>
            <?php endif; ?>
             <tr>
                <th scope="row">
                    <label for="wics-customer-id">Customer Number</label>
                </th>
                <td>
                    <input style="width: 300px;" value="<?php echo \Wics\Settings::getSetting('customer_id') ?>" type="text" id="wics-customer-id" name="wics-customer-id" >	
               		<p style="font-style: italic; font-size: small;"><span>Your Welpp customer number.</span></p>
                </td>
            </tr>
            <tr>
            	
            </tr>
            <tr>
                <th scope="row">
                    <label for="wics-username">Apikey</label>
                </th>
                <td>
                    <input style="width: 300px;" value="<?php echo \Wics\Settings::getSetting('username') ?>" type="text" id="wics-username" name="wics-username">
                	<p style="font-style: italic; font-size: small;"><span>Your Welpp apikey.</span></p>
                </td>
            </tr>
            <tr>
                <th scope="row">
                    <label for="wics-password">Apisecret</label>
                </th>
                <td>
                    <input style="width: 300px;" value="<?php echo \Wics\Settings::getSetting('password') ?>" type="password" id="wics-password" name="wics-password">
                	<p style="font-style: italic; font-size: small;"><span>Your Welpp apisecret.</span></p>
                </td>
            </tr>
            
            <tr>
                <th scope="row">
                    <label for="wics-url">URL</label>
                </th>
                <td>
                    <input style="width: 300px;" value="<?php echo \Wics\Settings::getSetting('url') ?>" type="text" id="wics-url" name="wics-url">
                	<p style="font-style: italic; font-size: small;"><span>The Welpp URL i.e. https://[your].welpp.nl/api/ .</span></p>
                </td>
            </tr>
      
            <tr>
                <th scope="row">
                    <label for="wics-customer-id">Order status enabled</label>
                </th>
                <td>
                    <input value="true" <?php echo \Wics\Settings::getSetting('sync-order-status') == true ? 'checked' : '' ?> type="checkbox" id="wics-sync-order-status" name="wics-sync-order-status">
                	<p style="font-style: italic; font-size: small;"><span>Orders will be updated with shipping details of the Welpp API.</span></p>
                </td>
            </tr>
            <tr>
                <th scope="row">
                    <label for="wics-customer-id">Stock sync enabled</label>
                </th>
                <td>
                    <input value="true" <?php echo \Wics\Settings::getSetting('sync-stock') == true ? 'checked' : '' ?>  type="checkbox" id="wics-sync-stock" name="wics-sync-stock">
               	    <p style="font-style: italic; font-size: small;"><span>The stock levels will be updated with the Welpp API.</span></p>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Opslaan">
                </td>
            </tr>
        </tbody>
    </table>
</form>